## git-annex 4.20130501ubuntu1

=== Makefile ===
mans=git-annex.1 git-annex-shell.1
all=git-annex $(mans) docs

GHC?=ghc
GHCMAKE=$(GHC) $(GHCFLAGS) --make
PREFIX=/usr
CABAL?=cabal # set to "./Setup" if you lack a cabal program

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

build: build-stamp
build-stamp: $(all)
	touch $@

Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
	$(CABAL) configure

git-annex: Build/SysConfig.hs
	$(CABAL) build
	ln -sf dist/build/git-annex/git-annex git-annex

git-annex.1: doc/git-annex.mdwn
	./Build/mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1
git-annex-shell.1: doc/git-annex-shell.mdwn
	./Build/mdwn2man git-annex-shell 1 doc/git-annex-shell.mdwn > git-annex-shell.1

git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1

install-mans: $(mans)
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/share/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/share/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/share/doc/git-annex/html/; \
	fi

install: build install-docs Build/InstallDesktopFile
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true

test: git-annex
	./git-annex test

# hothasktags chokes on some tempolate haskell etc, so ignore errors
tags:
	find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$' | xargs hothasktags > tags 2>/dev/null

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

docs: $(mans)
	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --disable-plugin=shortcut \
		--disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='news/.*' --exclude='design/assistant/blog/*' \
		--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*'

clean:
	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
		doc/.ikiwiki html dist tags Build/SysConfig.hs build-stamp \
		Setup Build/InstallDesktopFile Build/EvilSplicer \
		Build/Standalone Build/OSXMkLibs
	find -name \*.o -or -name \*.hi -exec rm {} \;

Build/InstallDesktopFile: Build/InstallDesktopFile.hs
	$(GHC) --make $@
Build/EvilSplicer: Build/EvilSplicer.hs
	$(GHC) --make $@
Build/Standalone: Build/Standalone.hs Build/SysConfig.hs
	$(GHC) --make $@
Build/OSXMkLibs: Build/OSXMkLibs.hs
	$(GHC) --make $@

sdist: clean $(mans)
	./Build/make-sdist.sh

# Upload to hackage.
hackage: sdist
	@cabal upload dist/*.tar.gz

LINUXSTANDALONE_DEST=tmp/git-annex.linux
linuxstandalone: Build/Standalone
	$(MAKE) git-annex

	rm -rf "$(LINUXSTANDALONE_DEST)"
	mkdir -p tmp
	cp -R standalone/linux "$(LINUXSTANDALONE_DEST)"

	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp git-annex "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE

	./Build/Standalone "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
	install -d "$(LINUXSTANDALONE_DEST)/templates"
	
	touch "$(LINUXSTANDALONE_DEST)/libdirs.tmp"
	for lib in $$(ldd "$(LINUXSTANDALONE_DEST)"/bin/* $$(find "$(LINUXSTANDALONE_DEST)"/git-core/ -type f) | grep -v -f standalone/linux/glibc-libs | grep -v "not a dynamic executable" | egrep '^	' | sed 's/^\t//' | sed 's/.*=> //' | cut -d ' ' -f 1 | sort | uniq); do \
		dir=$$(dirname "$$lib"); \
		install -d "$(LINUXSTANDALONE_DEST)/$$dir"; \
		echo "$$dir" >> "$(LINUXSTANDALONE_DEST)/libdirs.tmp"; \
		cp "$$lib" "$(LINUXSTANDALONE_DEST)/$$dir"; \
		if [ -L "$lib" ]; then \
			link=$$(readlink -f "$$lib"); \
			cp "$$link" "$(LINUXSTANDALONE_DEST)/$$(dirname "$$link")"; \
		fi; \
	done
	sort "$(LINUXSTANDALONE_DEST)/libdirs.tmp" | uniq > "$(LINUXSTANDALONE_DEST)/libdirs"
	rm -f "$(LINUXSTANDALONE_DEST)/libdirs.tmp"

	cd tmp && tar czf git-annex-standalone-$(shell dpkg --print-architecture).tar.gz git-annex.linux

OSXAPP_DEST=tmp/build-dmg/git-annex.app
OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
osxapp: Build/Standalone Build/OSXMkLibs
	$(MAKE) git-annex

	rm -rf "$(OSXAPP_DEST)"
	install -d tmp/build-dmg
	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"

	install -d "$(OSXAPP_BASE)"
	cp git-annex "$(OSXAPP_BASE)"
	strip "$(OSXAPP_BASE)/git-annex"
	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt

	./Build/Standalone $(OSXAPP_BASE)

	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
	install -d "$(OSXAPP_BASE)/templates"

	./Build/OSXMkLibs $(OSXAPP_BASE)
	rm -f tmp/git-annex.dmg
	hdiutil create -size 640m -format UDRW -srcfolder tmp/build-dmg \
		-volname git-annex -o tmp/git-annex.dmg
	rm -f tmp/git-annex.dmg.bz2
	bzip2 --fast tmp/git-annex.dmg

ANDROID_FLAGS=
# Cross compile for Android.
# Uses https://github.com/neurocyte/ghc-android
android: Build/EvilSplicer
	echo "Running native build, to get TH splices.."
	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f"-Production $(ANDROID_FLAGS)" -O0; fi
	mkdir -p tmp
	if ! $(CABAL) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
	echo "Setting up Android build tree.."
	./Build/EvilSplicer tmp/splices tmp/dump-splices standalone/android/evilsplicer-headers.hs
	rsync -az --exclude tmp --exclude dist . tmp/androidtree
# Copy the files with expanded splices to the source tree, but
# only if the existing source file is not newer. (So, if a file
# used to have TH splices but they were removed, it will be newer,
# and not overwritten.)
	cp -uR tmp/splices/* tmp/androidtree
# Some additional dependencies needed by the expanded splices.
	sed -i 's/^  Build-Depends: /  Build-Depends: yesod-routes, yesod-core, shakespeare-css, shakespeare-js, shakespeare, blaze-markup, file-embed, wai-app-static, /' tmp/androidtree/git-annex.cabal
# Avoid warnings due to sometimes unused imports added for the splices.
	sed -i 's/GHC-Options: \\(.*\\)-Wall/GHC-Options: \\1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
# Cabal cannot cross compile with custom build type, so workaround.
	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
	if [ ! -e tmp/androidtree/dist/setup/setup ]; then \
		cd tmp/androidtree; \
		cabal configure; \
		$$HOME/.ghc/android-14/arm-linux-androideabi-4.7/arm-linux-androideabi/bin/cabal configure -f"Android $(ANDROID_FLAGS)"; \
	fi
	$(MAKE) -C tmp/androidtree git-annex

androidapp:
	$(MAKE) android
	$(MAKE) -C standalone/android

# We bypass cabal, and only run the main ghc --make command for a
# fast development built. Note: Does not rebuild C libraries.
fast: dist/caballog
	@$$(grep 'ghc --make' dist/caballog | head -n 1 | sed -e 's/-package-id [^ ]*//g' -e 's/-hide-all-packages//') -O0
	@ln -sf dist/build/git-annex/git-annex git-annex
	@$(MAKE) tags >/dev/null 2>&1 &

dist/caballog: git-annex.cabal
	$(CABAL) configure -f"-Production" -O0
	$(CABAL) build -v2 | tee $@

# Hardcoded command line to make hdevtools start up and work.
# You will need some memory. It's worth it.
# Note: Don't include WebDAV or Webapp. TH use bloats memory > 500 mb!
# TODO should be possible to derive this from caballog.
hdevtools:
	hdevtools --stop-server || true
	hdevtools check git-annex.hs -g -cpp -g -i -g -idist/build/git-annex/git-annex-tmp -g -i. -g -idist/build/autogen -g -Idist/build/autogen -g -Idist/build/git-annex/git-annex-tmp -g -IUtility -g -DWITH_TESTSUITE -g -DWITH_S3 -g -DWITH_ASSISTANT -g -DWITH_INOTIFY -g -DWITH_DBUS -g -DWITH_PAIRING -g -DWITH_XMPP -g -optP-include -g -optPdist/build/autogen/cabal_macros.h -g -odir -g dist/build/git-annex/git-annex-tmp -g -hidir -g dist/build/git-annex/git-annex-tmp -g -stubdir -g dist/build/git-annex/git-annex-tmp -g -threaded -g -Wall -g -XHaskell98

.PHONY: git-annex tags build-stamp

=== standalone/android/Makefile ===
# Cross-compiles utilities needed for git-annex on Android,
# and builds the Android app.

# Add Android cross-compiler to PATH (as installed by ghc-android)
# (This directory also needs to have a cc that is a symlink to the prefixed
# gcc cross-compiler executable.)
ANDROID_CROSS_COMPILER?=$(HOME)/.ghc/android-14/arm-linux-androideabi-4.7/bin
PATH:=$(ANDROID_CROSS_COMPILER):$(PATH)

# Paths to the Android SDK and NDK.
export ANDROID_SDK_ROOT?=$(HOME)/tmp/adt-bundle-linux-x86/sdk
export ANDROID_NDK_ROOT?=$(HOME)/tmp/android-ndk-r8d

# Where to store the $(GIT_ANNEX_ANDROID_SOURCETREE)s to utilities. This
# directory will be created by `make source`.
GIT_ANNEX_ANDROID_SOURCETREE?=../tmp/android-sourcetree

GITTREE=$(GIT_ANNEX_ANDROID_SOURCETREE)/git/installed-tree

build: start
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/git/build-stamp
	$(MAKE) $(GIT_ANNEX_ANDROID_SOURCETREE)/term/build-stamp

	# Debug build because it does not need signing keys.
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && tools/build-debug

	# Install executables as pseudo-libraries so they will be
	# unpacked from the .apk.
	mkdir -p $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi
	cp ../../tmp/androidtree/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/busybox $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.busybox.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/ssh $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.ssh.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/ssh-keygen $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.ssh-keygen.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/rsync $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.rsync.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg/g10/gpg $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.gpg.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/git/git $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/git/git-shell $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-shell.so
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/git/git-upload-pack $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-upload-pack.so
	arm-linux-androideabi-strip --strip-unneeded --remove-section=.comment --remove-section=.note $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/*
	cp runshell $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.runshell.so
	cp start $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.start.so
	
	# remove git stuff we don't need to save space
	rm -rf $(GITTREE)/bin/git-cvsserver \
		$(GITTREE)/libexec/git-core/git-daemon \
		$(GITTREE)/libexec/git-core/git-show-index \
		$(GITTREE)/libexec/git-core/mergetools \
		$(GITTREE)/libexec/git-core/git-credential-* \
		$(GITTREE)/libexec/git-core/git-cvsserver \
		$(GITTREE)/libexec/git-core/git-cvsimport \
		$(GITTREE)/libexec/git-core/git-fast-import \
		$(GITTREE)/libexec/git-core/git-http-backend \
		$(GITTREE)/libexec/git-core/git-imap-send \
		$(GITTREE)/libexec/git-core/git-instaweb \
		$(GITTREE)/libexec/git-core/git-p4 \
		$(GITTREE)/libexec/git-core/git-remote-test* \
		$(GITTREE)/libexec/git-core/git-submodule \
		$(GITTREE)/libexec/git-core/git-svn \
		$(GITTREE)/libexec/git-core/git-web--browse
	# Most of git is in one multicall binary, but a few important
	# commands are still shell scripts. Those are put into
	# a tarball, along with a list of all the hard links that should be
	# set up.
	cd $(GITTREE) && mkdir -p links
	cd $(GITTREE) && find -samefile bin/git -not -wholename ./bin/git > links/git
	cd $(GITTREE) && find -samefile bin/git-shell -not -wholename ./bin/git-shell > links/git-shell
	cd $(GITTREE) && find -samefile bin/git-upload-pack -not -wholename ./bin/git-upload-pack > links/git-upload-pack
	cd $(GITTREE) && find -type f -not -samefile bin/git -not -samefile bin/git-shell -not -samefile bin/git-upload-pack|tar czf ../git.tar.gz -T -
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/git/git.tar.gz $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git.tar.gz.so

	git rev-parse HEAD > $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.version.so

	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && ant debug
	mkdir -p ../../tmp
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/term/bin/Term-debug.apk ../../tmp/git-annex.apk

$(GIT_ANNEX_ANDROID_SOURCETREE)/openssl/build-stamp:
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl && CC=$$(which cc) ./Configure android
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl && $(MAKE)
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/build-stamp: openssh.patch openssh.config.h
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && git reset --hard
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && ./configure --host=arm-linux-androideabi --with-ssl-dir=../openssl --without-openssl-header-check
	cat openssh.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && patch -p1)
	cp openssh.config.h $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/config.h
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && sed -i -e 's/getrrsetbyname.o //' openbsd-compat/Makefile
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && sed -i -e 's/auth-passwd.o //' Makefile
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && $(MAKE) ssh ssh-keygen
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/build-stamp: busybox_config
	cp busybox_config $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/.config
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox && yes '' | $(MAKE) oldconfig
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox && $(MAKE)
	touch $@
	
$(GIT_ANNEX_ANDROID_SOURCETREE)/git/build-stamp:
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/git && $(MAKE) install NO_OPENSSL=1 NO_GETTEXT=1 NO_GECOS_IN_PWENT=1 NO_GETPASS=1 NO_NSEC=1 NO_MKDTEMP=1 NO_PTHREADS=1 NO_PERL=1 NO_CURL=1 NO_EXPAT=1 NO_TCLTK=1 NO_ICONV=1 prefix= DESTDIR=installed-tree
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/build-stamp: rsync.patch
	cat rsync.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && git reset --hard origin/master && git am)
	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/automake/lib/config.sub $(GIT_ANNEX_ANDROID_SOURCETREE)/automake/lib/config.guess $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && ./configure --host=arm-linux-androideabi --disable-locale --disable-iconv-open --disable-iconv --disable-acl-support --disable-xattr-support
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && $(MAKE)
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg/build-stamp:
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && git checkout gnupg-1.4.13
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && ./autogen.sh
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && ./configure --host=arm-linux-androideabi --disable-gnupg-iconv --enable-minimal --disable-card-support --disable-agent-support --disable-photo-viewers --disable-keyserver-helpers --disable-nls
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg; $(MAKE) || true # expected failure in doc build
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/term/build-stamp: term.patch icons
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && git reset --hard
	cat term.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && patch -p1)
	(cd icons && tar c .) | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term/res && tar x)
	# This renaming has a purpose. It makes the path to the app's
	# /data directory shorter, which makes ssh connection caching
	# sockets placed there have more space for their filenames.
	# Also, it avoids overlap with the Android Terminal Emulator
	# app, if it's also installed.
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && find -name .git -prune -o -type f -print0 | xargs -0 perl -pi -e 's/jackpal/ga/g'
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && perl -pi -e 's/Terminal Emulator/Git Annex/g' res/*/strings.xml
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && tools/update.sh >/dev/null 2>&1
	touch $@

source: $(GIT_ANNEX_ANDROID_SOURCETREE)

$(GIT_ANNEX_ANDROID_SOURCETREE):
	mkdir -p $(GIT_ANNEX_ANDROID_SOURCETREE)
	git clone --bare git://git.savannah.gnu.org/automake.git $(GIT_ANNEX_ANDROID_SOURCETREE)/automake
	git clone --bare git://git.debian.org/git/d-i/busybox $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox
	git clone --bare git://git.kernel.org/pub/scm/git/git.git $(GIT_ANNEX_ANDROID_SOURCETREE)/git
	git clone --bare git://git.samba.org/rsync.git $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync
	git clone --bare git://git.gnupg.org/gnupg.git $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg
	git clone --bare git://git.openssl.org/openssl $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl
	git clone --bare git://github.com/CyanogenMod/android_external_openssh.git $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh
	git clone --bare git://github.com/jackpal/Android-Terminal-Emulator.git $(GIT_ANNEX_ANDROID_SOURCETREE)/term

clean:
	rm -rf $(GITTREE)
	rm -f start

reallyclean: clean
	rm -rf $(GIT_ANNEX_ANDROID_SOURCETREE)

=== debian/changelog ===
git-annex (4.20130501ubuntu1) saucy; urgency=low

  * Resynchronise with Debian (LP: #1174746).  Remaining changes:
    - Build the webapp on powerpc, since it has Template Haskell now.
    - Add BD on libghc-extensible-exceptions-dev; newly required with new
      GHC. 

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 15 May 2013 10:40:42 +0100

git-annex (4.20130501) unstable; urgency=low

  * sync, assistant: Behavior changes: Sync with remotes that have
    annex-ignore set, so that git remotes on servers without git-annex
    installed can be used to keep clients' git repos in sync.
  * assistant: Work around misfeature in git 1.8.2 that makes
    `git commit --alow-empty -m ""` run an editor.
  * sync: Bug fix, avoid adding to the annex the 
    dummy symlinks used on crippled filesystems.
  * Add public repository group.
    (And inpreferreddir to preferred content expressions.)
  * webapp: Can now set up Internet Archive repositories.
  * S3: Dropping content from the Internet Archive doesn't work, but
    their API indicates it does. Always refuse to drop from there.
  * Automatically register public urls for files uploaded to the
    Internet Archive.
  * To enable an existing special remote, the new enableremote command
    must be used. The initremote command now is used only to create
    new special remotes.
  * initremote: If two existing remotes have the same name,
    prefer the one with a higher trust level.
  * assistant: Improved XMPP protocol to better support multiple repositories
    using the same XMPP account. Fixes bad behavior when sharing with a friend
    when you or the friend have multiple reposotories on an XMPP account.
    Note that XMPP pairing with your own devices still pairs with all
    repositories using your XMPP account.
  * assistant: Fix bug that could cause incoming pushes to not get
    merged into the local tree. Particularly affected XMPP pushes.
  * webapp: Display some additional information about a repository on
    its edit page.
  * webapp: Install FDO desktop menu file when started in standalone mode.
  * webapp: Don't default to making repository in cwd when started
    from within a directory containing a git-annex file (eg, standalone
    tarball directory).
  * Detect systems that have no user name set in GECOS, and also
    don't have user.name set in git config, and put in a workaround
    so that commits to the git-annex branch (and the assistant)
    will still succeed despite git not liking the system configuration.
  * webapp: When told to add a git repository on a remote server, and
    the repository already exists as a non-bare repository, use it,
    rather than initializing a bare repository in the same directory.
  * direct, indirect: Refuse to do anything when the assistant
    or git-annex watch daemon is running.
  * assistant: When built with git before 1.8.0, use `git remote rm`
    to delete a remote. Newer git uses `git remote remove`.
  * rmurl: New command, removes one of the recorded urls for a file.
  * Detect when the remote is broken like bitbucket is, and exits 0 when
    it fails to run git-annex-shell.
  * assistant: Several improvements to performance and behavior when
    performing bulk adds of a large number of files (tens to hundreds
    of thousands).
  * assistant: Sanitize XMPP presence information logged for debugging.
  * webapp: Now automatically fills in any creds used by an existing remote
    when creating a new remote of the same type. Done for Internet Archive,
    S3, Glacier, and Box.com remotes.
  * Store an annex-uuid file in the bucket when setting up a new S3 remote.
  * Support building with DAV 0.4.

 -- Joey Hess <joeyh@debian.org>  Wed, 01 May 2013 01:42:46 -0400

git-annex (4.20130417) unstable; urgency=low

  * initremote: Generates encryption keys with high quality entropy.
    This can be disabled using --fast to get the old behavior.
    The assistant still uses low-quality entropy when creating encrypted
    remotes, to avoid delays. (Thanks, guilhem for the patch.)
  * Bugfix: Direct mode no longer repeatedly checksums duplicated files.
  * assistant: Work around horrible, terrible, very bad behavior of
    gnome-keyring, by not storing special-purpose ssh keys in ~/.ssh/*.pub.
    Apparently gnome-keyring apparently will load and indiscriminately use
    such keys in some cases, even if they are not using any of the standard
    ssh key names. Instead store the keys in ~/.ssh/annex/,
    which gnome-keyring will not check.
  * addurl: Bugfix: Did not properly add file in direct mode.
  * assistant: Bug fix to avoid annexing the files that git uses
    to stand in for symlinks on FAT and other filesystem not supporting
    symlinks.
  * Adjust preferred content expressions so that content in archive
    directories is preferred until it has reached an archive or smallarchive
    repository.
  * webapp: New --listen= option allows running the webapp on one computer
    and connecting to it from another. (Note: Does not yet use HTTPS.)
  * Added annex.web-download-command setting.
  * Added per-remote annex-rsync-transport option. (guilhem again)
  * Ssh connection caching is now also used by rsync special remotes.
    (guilhem yet again)
  * The version number is now derived from git, unless built with
    VERSION_FROM_CHANGELOG.
  * assistant: Stop any transfers the assistant initiated on shutdown.
  * assistant: Added sequence numbers to XMPP git push packets. (Not yet used.)
  * addurl: Register transfer so the webapp can see it.
  * addurl: Automatically retry downloads that fail, as long as some
    additional content was downloaded.
  * webapp: Much improved progress bar display for downloads from encrypted
    remotes.
  * Avoid using runghc, as that needs ghci.
  * webapp: When a repository's group is changed, rescan for transfers.
  * webapp: Added animations.
  * webapp: Include the repository directory in the mangled hostname and


=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 7.4),
	libghc-mtl-dev (>= 2.1.1),
	libghc-missingh-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-sha-dev,
	libghc-regex-tdfa-dev,
	libghc-dataenc-dev,
	libghc-utf8-string-dev,
	libghc-hs3-dev (>= 0.5.6),
	libghc-dav-dev (>= 0.3) [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc sparc],
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-lifted-base-dev,
	libghc-dlist-dev,
	libghc-uuid-dev,
	libghc-json-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-hinotify-dev [linux-any],
	libghc-stm-dev (>= 2.3),
	libghc-dbus-dev (>= 0.10.3) [linux-any],
	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-yesod-default-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-warp-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-wai-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-wai-logger-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-transformers-dev,
	libghc-blaze-builder-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev,
	libghc-safesemaphore-dev,
	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
	libghc-gnutls-dev (>= 0.1.4),
	libghc-xml-types-dev,
	libghc-async-dev,
	libghc-http-dev,
	libghc-extensible-exceptions-dev,
	ikiwiki,
	perlmagick,
	git,
	rsync,
	wget,
	curl,
	openssh-client,
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.9.3
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.7.7.6),
	rsync,
	wget,
	curl,
	openssh-client (>= 1:5.6p1)
Recommends: lsof, gnupg, bind9-host
Suggests: graphviz, bup, libnss-mdns
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 Even without file content tracking, being able to manage files with git,
 move files around and delete files with versioned directory trees, and use
 branches and distributed clones, are all very handy reasons to use git. And
 annexed files can co-exist in the same git repository with regularly
 versioned files, which is convenient for maintaining documents, Makefiles,
 etc that are associated with annexed files but that benefit from full
 revision control.

=== debian/rules ===
#!/usr/bin/make -f

# Avoid using cabal, as it writes to $HOME
export CABAL=./Setup

# Do use the changelog's version number, rather than making one up.
export VERSION_FROM_CHANGELOG=1

%:
	dh $@

# Not intended for use by anyone except the author.
announcedir:
	@echo ${HOME}/src/git-annex/doc/news

## git-annex 4.20130516ubuntu1

=== Makefile ===
--- 
+++ 
@@ -158,7 +158,7 @@
 	rm -f tmp/git-annex.dmg.bz2
 	bzip2 --fast tmp/git-annex.dmg
 
-ANDROID_FLAGS=
+ANDROID_FLAGS?=
 # Cross compile for Android.
 # Uses https://github.com/neurocyte/ghc-android
 android: Build/EvilSplicer
@@ -173,19 +173,21 @@
 # only if the existing source file is not newer. (So, if a file
 # used to have TH splices but they were removed, it will be newer,
 # and not overwritten.)
-	cp -uR tmp/splices/* tmp/androidtree
+	cp -uR tmp/splices/* tmp/androidtree || true
 # Some additional dependencies needed by the expanded splices.
 	sed -i 's/^  Build-Depends: /  Build-Depends: yesod-routes, yesod-core, shakespeare-css, shakespeare-js, shakespeare, blaze-markup, file-embed, wai-app-static, /' tmp/androidtree/git-annex.cabal
 # Avoid warnings due to sometimes unused imports added for the splices.
-	sed -i 's/GHC-Options: \\(.*\\)-Wall/GHC-Options: \\1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
+	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
 # Cabal cannot cross compile with custom build type, so workaround.
 	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
 	if [ ! -e tmp/androidtree/dist/setup/setup ]; then \
-		cd tmp/androidtree; \
-		cabal configure; \
-		$$HOME/.ghc/android-14/arm-linux-androideabi-4.7/arm-linux-androideabi/bin/cabal configure -f"Android $(ANDROID_FLAGS)"; \
+		cd tmp/androidtree && $$HOME/.ghc/android-14/arm-linux-androideabi-4.7/arm-linux-androideabi/bin/cabal configure -f"Android $(ANDROID_FLAGS)"; \
 	fi
-	$(MAKE) -C tmp/androidtree git-annex
+	cd tmp/androidtree && $(CABAL) build
+
+adb:
+	ANDROID_FLAGS="-Production" $(MAKE) android
+	adb push tmp/androidtree/dist/build/git-annex/git-annex /data/data/ga.androidterm/bin/git-annex
 
 androidapp:
 	$(MAKE) android

=== standalone/android/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 # Where to store the $(GIT_ANNEX_ANDROID_SOURCETREE)s to utilities. This
 # directory will be created by `make source`.
-GIT_ANNEX_ANDROID_SOURCETREE?=../tmp/android-sourcetree
+GIT_ANNEX_ANDROID_SOURCETREE?=$(HOME)/tmp/android-sourcetree
 
 GITTREE=$(GIT_ANNEX_ANDROID_SOURCETREE)/git/installed-tree
 
@@ -32,7 +32,7 @@
 	# Install executables as pseudo-libraries so they will be
 	# unpacked from the .apk.
 	mkdir -p $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi
-	cp ../../tmp/androidtree/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
+	cp ../../tmp/androidtree/dist/build/git-annex/git-annex $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.git-annex.so
 	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/busybox $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.busybox.so
 	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/ssh $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.ssh.so
 	cp $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/ssh-keygen $(GIT_ANNEX_ANDROID_SOURCETREE)/term/libs/armeabi/lib.ssh-keygen.so

=== debian/changelog ===
git-annex (4.20130516ubuntu1) saucy; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Build the webapp on powerpc, since it has Template Haskell now.
    - Add BD on libghc-extensible-exceptions-dev; newly required with new
      GHC. 

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 17 May 2013 01:11:46 +0100

git-annex (4.20130516) unstable; urgency=low

  * Android: The webapp is ported and working.
  * Windows: There is a very rough Windows port. Do not trust it with
    important data.
  * git-annex-shell: Ensure that received files can be read. Files
    transferred from some Android devices may have very broken permissions
    as received.
  * direct mode: Direct mode commands now work on files staged in the index,
    they do not need to be committed to git.
  * Temporarily add an upper bound to the version of yesod that can be built
    with, since yesod 1.2 has a great many changes that will require extensive
    work on the webapp.
  * Disable building with the haskell threaded runtime when the assistant
    is not built. This may fix builds on s390x and sparc, which are failing
    to link -lHSrts_thr
  * Avoid depending on regex-tdfa on mips, mipsel, and s390, where it fails
    to build.
  * direct: Fix a bug that could cause some files to be left in indirect mode.
  * When initializing a directory special remote with a relative path,
    the path is made absolute.
  * SHA: Add a runtime sanity check that sha commands output something
    that appears to be a real sha.
  * configure: Better checking that sha commands output in the desired format.
  * rsync special remotes: When sending from a crippled filesystem, use
    the destination's default file permissions, as the local ones can
    be arbitrarily broken. (Ie, ----rwxr-x for files on Android)
  * migrate: Detect if a file gets corrupted while it's being migrated.
  * Debian: Add a menu file.

 -- Joey Hess <joeyh@debian.org>  Thu, 16 May 2013 11:03:35 -0400

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	libghc-hslogger-dev,
 	libghc-pcre-light-dev,
 	libghc-sha-dev,
-	libghc-regex-tdfa-dev,
+	libghc-regex-tdfa-dev [!mips !mipsel !s390],
 	libghc-dataenc-dev,
 	libghc-utf8-string-dev,
 	libghc-hs3-dev (>= 0.5.6),
@@ -17,6 +17,7 @@
 	libghc-quickcheck2-dev,
 	libghc-monad-control-dev (>= 0.3),
 	libghc-lifted-base-dev,
+	libghc-unix-compat-dev,
 	libghc-dlist-dev,
 	libghc-uuid-dev,
 	libghc-json-dev,
@@ -40,7 +41,7 @@
 	libghc-blaze-builder-dev,
 	libghc-crypto-api-dev,
 	libghc-network-multicast-dev,
-	libghc-network-info-dev,
+	libghc-network-info-dev [linux-any kfreebsd-any],
 	libghc-safesemaphore-dev,
 	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
 	libghc-gnutls-dev (>= 0.1.4),

## git-annex 4.20130516ubuntu2

=== debian/changelog ===
git-annex (4.20130516ubuntu2) saucy; urgency=low

  * Build/Configure.hs: Only take characters from the changelog version that
    are valid in Cabal versions.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 17 May 2013 10:31:59 +0100

## git-annex 4.20130521ubuntu1

=== debian/changelog ===
git-annex (4.20130521ubuntu1) saucy; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Build the webapp on powerpc, since it has Template Haskell now.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 23 May 2013 10:14:56 +0100

git-annex (4.20130521) unstable; urgency=low

  * Sanitize debian changelog version before putting it into cabal file.
    Closes: #708619
  * Switch to MonadCatchIO-transformers for better handling of state while
    catching exceptions.
  * Fix a zombie that could result when running a process like gpg to
    read and write to it.
  * Allow building with gpg2.
  * Disable building with the haskell threaded runtime when the webapp
    is not built. This may fix builds on mips, s390x and sparc, which are
    failing to link -lHSrts_thr
  * Temporarily build without webapp on kfreebsd-i386, until yesod is
    installable there again.
  * Direct mode bug fix: After a conflicted merge was automatically resolved,
    the content of a file that was already present could incorrectly
    be replaced with a symlink.
  * Fix a bug in the git-annex branch handling code that could
    cause info from a remote to not be merged and take effect immediately.
  * Direct mode is now fully tested by the test suite.
  * Detect bad content in ~/.config/git-annex/program and look in PATH instead.
  * OSX: Fixed gpg included in dmg.
  * Linux standalone: Back to being built with glibc 2.13 for maximum
    portability.

 -- Joey Hess <joeyh@debian.org>  Tue, 21 May 2013 13:10:26 -0400

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	libghc-dav-dev (>= 0.3) [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc sparc],
 	libghc-quickcheck2-dev,
 	libghc-monad-control-dev (>= 0.3),
-	libghc-lifted-base-dev,
+	libghc-monadcatchio-transformers-dev,
 	libghc-unix-compat-dev,
 	libghc-dlist-dev,
 	libghc-uuid-dev,
@@ -24,12 +24,13 @@
 	libghc-ifelse-dev,
 	libghc-bloomfilter-dev,
 	libghc-edit-distance-dev,
+	libghc-extensible-exceptions-dev,
 	libghc-hinotify-dev [linux-any],
 	libghc-stm-dev (>= 2.3),
 	libghc-dbus-dev (>= 0.10.3) [linux-any],
 	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
-	libghc-yesod-default-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
+	libghc-yesod-default-dev [i386 amd64 kfreebsd-amd64 powerpc],
 	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-warp-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
@@ -37,7 +38,6 @@
 	libghc-wai-logger-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
 	libghc-case-insensitive-dev,
 	libghc-http-types-dev,
-	libghc-transformers-dev,
 	libghc-blaze-builder-dev,
 	libghc-crypto-api-dev,
 	libghc-network-multicast-dev,
@@ -48,7 +48,6 @@
 	libghc-xml-types-dev,
 	libghc-async-dev,
 	libghc-http-dev,
-	libghc-extensible-exceptions-dev,
 	ikiwiki,
 	perlmagick,
 	git,

## git-annex 4.20130621

=== Makefile ===
--- 
+++ 
@@ -50,7 +50,7 @@
 test: git-annex
 	./git-annex test
 
-# hothasktags chokes on some tempolate haskell etc, so ignore errors
+# hothasktags chokes on some template haskell etc, so ignore errors
 tags:
 	find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$' | xargs hothasktags > tags 2>/dev/null

=== standalone/android/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 export ANDROID_SDK_ROOT?=$(HOME)/tmp/adt-bundle-linux-x86/sdk
 export ANDROID_NDK_ROOT?=$(HOME)/tmp/android-ndk-r8d
 
-# Where to store the $(GIT_ANNEX_ANDROID_SOURCETREE)s to utilities. This
+# Where to store the source tree used to build utilities. This
 # directory will be created by `make source`.
 GIT_ANNEX_ANDROID_SOURCETREE?=$(HOME)/tmp/android-sourcetree
 
@@ -64,7 +64,7 @@
 		$(GITTREE)/libexec/git-core/git-web--browse
 	# Most of git is in one multicall binary, but a few important
 	# commands are still shell scripts. Those are put into
-	# a tarball, along with a list of all the hard links that should be
+	# a tarball, along with a list of all the links that should be
 	# set up.
 	cd $(GITTREE) && mkdir -p links
 	cd $(GITTREE) && find -samefile bin/git -not -wholename ./bin/git > links/git

=== debian/changelog ===
git-annex (4.20130621) unstable; urgency=low

  * Supports indirect mode on encfs in paranoia mode, and other
    filesystems that do not support hard links, but do support
    symlinks and other POSIX filesystem features.
  * Android: Add .thumbnails to .gitignore when setting up a camera
    repository.
  * Android: Make the "Open webapp" menu item open the just created
    repository when a new repo is made.
  * webapp: When the user switches to display a different repository,
    that repository becomes the default repository to be displayed next time
    the webapp gets started.
  * glacier: Better handling of the glacier inventory, which avoids
    duplicate uploads to the same glacier repository by `git annex copy`.
  * Direct mode: No longer temporarily remove write permission bit of files
    when adding them.
  * sync: Better support for bare git remotes. Now pushes directly to the
    master branch on such a remote, instead of to synced/master. This
    makes it easier to clone from a bare git remote that has been populated
    with git annex sync or by the assistant.
  * Android: Fix use of cp command to not try to use features present
    only on build system.
  * Windows: Fix hang when adding several files at once.
  * assistant: In direct mode, objects are now only dropped when all
    associated files are unwanted. This avoids a repreated drop/get loop
    of a file that has a copy in an archive directory, and a copy not in an
    archive directory. (Indirect mode still has some buggy behavior in this
    area, since it does not keep track of associated files.)
    Closes: #712060
  * status: No longer shows dead repositories.
  * annex.debug can now be set to enable debug logging by default.
    The webapp's debugging check box does this.
  * fsck: Avoid getting confused by Windows path separators
  * Windows: Multiple bug fixes, including fixing the data written to the
    git-annex branch.
  * Windows: The test suite now passes on Windows (a few broken parts are
    disabled).
  * assistant: On Linux, the expensive transfer scan is run niced.
  * Enable assistant and WebDAV support on powerpc and sparc architectures,
    which now have the necessary dependencies built.

 -- Joey Hess <joeyh@debian.org>  Fri, 21 Jun 2013 10:18:41 -0400

git-annex (4.20130601) unstable; urgency=medium

  * XMPP: Git push over xmpp made much more robust.
  * XMPP: Avoid redundant and unncessary pushes. Note that this breaks
    compatibility with previous versions of git-annex, which will refuse
    to accept any XMPP pushes from this version.
  * XMPP: Send pings and use them to detect when contact with the server
    is lost.
  * hook special remote: Added combined hook program support.
  * Android app: Avoid using hard links to app's lib directory, which
    is sometimes on a different filesystem than the data directory.
  * Fix bug in parsing of parens in some preferred content expressions.
    This fixes the behavior of the manual mode group.
  * assistant: Work around git-cat-file's not reloading the index after files
    are staged.
  * Improve error handling when getting uuid of http remotes to auto-ignore,
    like with ssh remotes.
  * content: New command line way to view and configure a repository's
    preferred content settings.
  * sync: Fix double merge conflict resolution handling.
  * XMPP: Fix a file descriptor leak.
  * Android: Added an "Open WebApp" item to the terminal's menu.
  * Android: Work around Android devices where the `am` command doesn't work.
  * Can now restart certain long-running git processes if they crash, and
    continue working.

 -- Joey Hess <joeyh@debian.org>  Sat, 01 Jun 2013 19:16:04 -0400

## git-annex 4.20130627

=== debian/changelog ===
git-annex (4.20130627) unstable; urgency=low

  * assistant --autostart: Automatically ionices the daemons it starts.
  * assistant: Daily sanity check thread is run niced.
  * bup: Handle /~/ in bup remote paths.
    Thanks, Oliver Matthews
  * fsck: Ensures that direct mode is used for files when it's enabled.
  * webapp: Fix bug when setting up a remote ssh repo repeatedly on the same
    server.
  * webapp: Ensure that ssh keys generated for different directories
    on a server are always different.
  * webapp: Fix bug setting up ssh repo if the user enters "~/" at the start 
    of the path.
  * assistant: Fix bug that prevented adding files written by gnucash, 
    and more generally support adding hard links to files. However,
    other operations on hard links are still unsupported.
  * webapp: Fix bug that caused the webapp to hang when built with yesod 1.2.

 -- Joey Hess <joeyh@debian.org>  Thu, 27 Jun 2013 14:21:55 -0400

=== debian/control ===
--- 
+++ 
@@ -28,14 +28,14 @@
 	libghc-hinotify-dev [linux-any],
 	libghc-stm-dev (>= 2.3),
 	libghc-dbus-dev (>= 0.10.3) [linux-any],
-	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
-	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
-	libghc-yesod-default-dev [i386 amd64 kfreebsd-amd64 powerpc],
-	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
-	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
-	libghc-warp-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
-	libghc-wai-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
-	libghc-wai-logger-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc],
+	libghc-yesod-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
+	libghc-yesod-static-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
+	libghc-yesod-default-dev [i386 amd64 kfreebsd-amd64 powerpc sparc],
+	libghc-hamlet-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
+	libghc-clientsession-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
+	libghc-warp-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
+	libghc-wai-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
+	libghc-wai-logger-dev [i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc sparc],
 	libghc-case-insensitive-dev,
 	libghc-http-types-dev,
 	libghc-blaze-builder-dev,
@@ -55,9 +55,8 @@
 	wget,
 	curl,
 	openssh-client,
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Joey Hess <joeyh@debian.org>
-Standards-Version: 3.9.3
+Maintainer: Joey Hess <joeyh@debian.org>
+Standards-Version: 3.9.4
 Vcs-Git: git://git.kitenet.net/git-annex
 Homepage: http://git-annex.branchable.com/
